// Module: DEBUG

#include <iostream.h>
/*
void Error( int nr )
  { cout << nr; };
enum { ErrNoMoMemory, ErrNew0, ErrInDelete };
*/
#include <conio.h>
void NativePrint(char* cp)
  { cputs(cp); };
char* CR="\r\n";

int TxtCursX() { return wherex(); };
//#include <new.h>
//#include <alloc.h>
#include <stdlib.h>
//#include <stdlib.h>

/* interface */

void* operator new(size_t s);

void operator delete(void* p);

class DebugMain
{ unsigned long HeapMem;

public:
  DebugMain();

  ~DebugMain();
};

/* implementation */

struct anAlloc {    // data keept of each allocation
   void*    p;          // where is it?
   unsigned s;          // which size has it? (eigt. size_t)
   char*    source;     // filename of source
   unsigned line;       // line in source
   // maybe add "time" and object name and ?
};

const unsigned sHCL=100;    // const size of the HCL array
unsigned       nHCL;        // next item in HCL
//unsigned       uHCL;        // used items in HCL
anAlloc        HCL[sHCL];   // array with all items
char*          HCnFile;     // argument passing new(T) macro to operator new()
unsigned       HCnLine;     // dito.

char* LineUnknown="--unknown--";

void InitHCL()
{ /*uHCL=0*/
   for(nHCL=0; nHCL<sHCL; nHCL++)
     HCL[nHCL].p=NULL;
   nHCL=0;
};

// #undef new(T)
void* operator new(size_t s)  {
  void* t;
  if(s) {
    t=malloc(s);
    if (t) {
      unsigned stop=nHCL-1;
      if(nHCL==0) stop=sHCL-1;
      while(HCL[nHCL].p && nHCL!=stop)
        if(nHCL<(sHCL-1)) ++nHCL; else nHCL=0;
      if(nHCL==stop && HCL[nHCL].p) NativePrint("HCL is FULL. NO MORE HEAP CHECKING... increase sHCL");
      else {
        HCL[nHCL].p=t;
        HCL[nHCL].s=s;
        if(HCnFile==0) HCnFile=LineUnknown;
        HCL[nHCL].source=HCnFile; HCnFile=NULL;
        HCL[nHCL].line=HCnLine;   HCnLine=0;
        if(++nHCL==sHCL) nHCL=0;
      };
    }
    else
      { NativePrint(CR); NativePrint("No more memory! [FATAL]");
        NativePrint(CR); abort();                                };
  } else
      { NativePrint(CR); NativePrint("Try to allocate (new) zero (0) bytes.");
        NativePrint(CR); /* don't abort. */                                 };
  return t;
};
#define new(T) (HCnFile=__FILE__, HCnLine=__LINE__, new T)

void operator delete(void* p) {
  // if ( heapchecknode(p) != _USEDENTRY )
  //  { Error(ErrInDelete); }
  unsigned stop=nHCL+1;
  if(nHCL==sHCL-1) stop=0;
  while(HCL[nHCL].p!=p && nHCL!=stop)
    if(nHCL!=0) --nHCL; else nHCL=sHCL-1;
  if(HCL[nHCL].p==p) // means: found
    { free(p); HCL[nHCL].p=NULL; };
};

inline void ForgotToFree(unsigned i)
  { // printf("FORGOT TO free() %u BYTES at %p // new()'d IN FILE <%s> #%u\n",HCL[i].s,HCL[i].p,HCL[i].source,HCL[i].line); };
    cerr << "FORGOT TO free() "<<HCL[i].s<<" BYTES at "<<HCL[i].p<<" // new()'d IN FILE <"
         <<HCL[i].source<<"> #"<<HCL[i].line<<endl; };

void CloseHCL()
{ unsigned stop=nHCL+1;
  if(nHCL==sHCL-1) stop=0;
  while(nHCL!=stop)
    { if(HCL[nHCL].p) ForgotToFree(nHCL);
      if(nHCL!=0) --nHCL; else nHCL=sHCL-1; };
  if(HCL[nHCL].p) ForgotToFree(nHCL); // check last item too.
};

DebugMain::DebugMain()
{ /*clrscr();*/ // HeapMem=coreleft();
  InitHCL();
  cerr << ">>>Program started>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" << endl;
};

DebugMain::~DebugMain()
{ // signed long diff=HeapMem-coreleft();
  // ?? [UNZUVERLSSIG] 48 bytes diff verschwinden offenbar wg. Klasse
  // ?? 32 sind es, wenn mind. eine Klasse mit virtuellen Methoden
  //if( (diff!=48) && (diff!=32) )
  //  NativePrint("Memory lost!"); NativePrint(CR);
    // cerr << "Memory lost! Diff=" << diff << " bytes" << endl;
  if(TxtCursX()>1) cerr << endl;
  cerr << "================================================================Program ended===" << endl;
  CloseHCL();
};

DebugMain debugMain;

void main()
{
   cout << "Hi!";
   int*  ip=new(int);
   int*  I=new(int);
   char* cp=new(char);
   long* lp=new(long);

   delete ip;
   delete I;
   delete lp;
};
