/* ------------------------------------------------------------------------ */
// ContainerABC<I, O> & Iter<I, O> - abstract base class for EVERYTHING

template<class I, class O> class ContainerABC : public Fruit
{ public:
   virtual void        Add(const I&)   = 0;
   virtual O           GetRemove()     = 0;
   virtual const bool  IsEmpty() const = 0;
   virtual             ~ContainerABC() { };

/* ContainerABC& operator+=(const I& e)   { Add(e); return *this; };
   ContainerABC& operator<<(const I& e)   { Add(e); return *this; };
   O          operator() ()            { return GetRemove();   };
              operator const bool()    { return !IsEmpty();    };

    ContainerABC() { };
    private:
      operator=(ContainerABC&); ContainerABC(ContainerABC&);
*/
};

template<class T> inline void Stack_Ill<T>::
Add(const T& a)
{ Node<T>* N=new Node<T>(a);
  if(last)
    N->lnk=last;
  else
    head=N;
  last=N;
};

template<class T> inline T Stack_Ill<T>::
GetRemove()
{ if(last) {
    T R=last->item;
    Node<T>* h=last->lnk;
    delete last;
    last=h;
    return R; }
  else
    Error(ErrContainerABCEmpty);
};
template<class T> inline void Stack_Ill<T>::
~Stack_Ill()
{};

/* ------------------------------------------------------------------------ */

