// PROJECT : ALIB (alpha library)
// FILE    : ERROR.H - header file for runtime errors
// AUTHOR  : Michael Vorburger, alpha ware, CH-SG
// DATE oC : January 1994
// DATE oLM: October 1994
// LEVEL   : GLE

/* This File contains the prototyp for the
   Error(..) function and others. See Error.CPP */

#ifndef __ERROR_H
#define __ERROR_H

enum ErrorCode
{
    ErrNone,
//  ErrNotOverloaded,
    ErrNotInitVar,
//  ErrNotUsedAnymore1,
//  ErrNotUsedAnymore2,
    ErrWrongDelete,     // if fruit deleted
    ErrTooManyYAF,
    ErrAccDelObj,
//  ErrCannotConvertFruit,
    ErrArrayBounds,
    ErrArrayOverflow,
    ErrOORinLA,  // Out Of Range In List Access
    ErrWrongIter,
    ErrContainerEmpty,
    ErrString,

// TERM spezifisch
    ErrUnknownClass,
    ErrNotImplemented,
    ErrDivByZero,
    Err0Power0,
    ErrOperUnknownType,

    ErrLAST
};

//enum ErrorAction { notice, none, breakApp };
//extern ErrorAction ErrWhatReact[ErrLAST];

//extern char* ErrMsgDt[];
//extern char* ErrMsgEgl[];

void Error( ErrorCode nr );

enum ErrorModeEnum { toCout, quiet };
enum ErrorLangEnum { english, deutsch };
void ErrorSetMode( ErrorModeEnum m, ErrorLangEnum l = english);

// Globale Fehler-Objekte (als Returnwert bei troubles)
// extern String StringErr;

#endif
