// PROJECT : ALIB
// FILE    : MSITEXT.H - machine specific implementation, text interface
// AUTHOR  : Michael Vorburger, alpha ware
// DATE oC : October 1994
// DATE oLM: October 1994
// LEVEL   : MSI

#ifndef __MSITEXT_H
#define __MSITEXT_H

# ifdef __cplusplus
  extern "C" {
# endif

// NativePrint() is a low level textscreen-output function. Don't use printf()
// or even cout here! Reentrance problems are one thing...
void NativePrint(const char* cp);
extern const char* CR;

// Return X-Position of text cursor from 1..80 (maybe more than 80, or always 1)
int TxtCursX();
# ifdef  __cplusplus
	}
# endif

#endif // __MSITEXT_H