#include <alobject.h>
#include <list.h>

class TestFruit : public Fruit // , public debugable
{
  SWORD s;

public:
  TestFruit(SWORD i)            { s=i; };
  TestFruit(const TestFruit& i) { s=i.s; };
  ~TestFruit()                  { };

  FRUITMACRO(TestFruit)
  //  TestFruit& Copy() const       { return *new TestFruit(*this); };
};

class Test : public Shell<TestFruit> // , public debugable
{
 public:
  Test(SWORD q)  { EqualFruitPtr(new TestFruit(q)); };
  SHELL_INTERFACE(Test,TestFruit)
};


void main()
{
  Test o1(1);
  Test o2(2);
  Test o;
//  Test o3(3);
//  Test o4(4);
//  Test o5(5);

  ListDyn<Test> List1(1,1);

  List1.Add(o1);
//  List1.Add(o2);
  cout<< List1[1]().s << " ";
//  cout << List1[2]().s << endl;

  o=List1[1];

  List1.Add(*new Test(100));
  cout << List1[2]().s << " ";
/*
  List1.Add(Test("dynamische vier"));
  cout << List1[2]().s << " ";

  List1.Add(Test("dynamische fnf"));
  cout << List1[2]().s << " ";

  cout << List1[3]().s << endl;
  cout<< List1[4]().s << " " << List1[5]().s << endl;
*/
};
