// #include <alphalib.h>
#include <alobject.h>

struct MyInt
 { int i;
   MyInt(int j) : i(j) {};
 };

#define hNew(T) (T)

void main()
{
// Trivial Handle for Primitives
 {THndP<int> hInt;

  hInt=3;  // NOT =new(int(3)); is WRONG!
  cout << *hInt << endl;

  { int i=*hInt; hInt=i; cout << *hInt << endl; };

  { int* pInt=new(int(7));
    hInt=*pInt; cout << hInt() << endl;
    delete pInt;                        };

  hInt=4;
  { int i=*hInt; cout << i << endl; }
 };

// Trivial Handle for Classes
 {THndC<MyInt> hMyInt1;

  hMyInt1=8; // 1. temporary MyInt is created
             // 2. the (1) is copied 3. the (1) is freed
  cout << hMyInt1->i << endl;

  { MyInt I=1; hMyInt1=I; cout << hMyInt1->i << endl; };

  { MyInt* pMyInt=new(MyInt(9));
    hMyInt1=*pMyInt; cout << hMyInt1->i << endl;
    delete pMyInt;                              };

  { THndC<MyInt> hMyInt2=hMyInt1;
     MyInt* pMyInt=&hMyInt1();
      pMyInt->i=0;                /* Verstehe nicht, warum dieses Obj nicht */
      // delete pMyInt;           /* <-- deleted werden muss. Kein Fehler.  */


    hMyInt2->i=3;
    cout << (*hMyInt2).i << endl;
    cout << hMyInt1().i << endl; };
 };

};
