#include <string.h>

class MyStringF : public Fruit {
   char* pc;
 public:
   MyStringF(const char* a)
      : pc(new(char[strlen(a)+1])) { strcpy(pc,a);                          };
   MyStringF(const char* a, const char* b)
      : pc(new(char[strlen(a)+strlen(b)+1])) { strcpy(pc,a); strcat(pc,b);  };
   MyStringF& operator=(const char* a)
      { delete[] pc; pc=new char[strlen(a)+1]; strcpy(pc,a); return *this; };
   MyStringF(const MyStringF& a)
      : pc(new(char[strlen(a.pc)+1])) { strcpy(pc,a.pc);                    };
   ~MyStringF()
      { delete[] pc;                                                       };
   FRUITMACRO(MyStringF)

 friend MyString;
 friend MyString operator+(const char * a,const MyString& S);
};

class MyString : public Hnd<MyStringF> {
 public:
   SHELL_INTERFACE(MyString,MyStringF)
   FRUITINIT_INTERFACE(MyString,MyStringF, char*)

   void Show() const            { cout << Frt().pc << " at " << (void*)&Frt() << endl; };

   void Change()                { (Frt().pc)[0]='-';                                     };

   MyString& operator+=(const char* a)
        { EqualFrtPtr(new(MyStringF(Frt().pc,a)));
          return *this;                 };
/*      { const MyStringF& F=Frt();
          MyStringF&       N=new(MyStringF(strlen(O.pc)+strlen(a)+1) );
          strcpy(N.pc,O.pc); strcat(N.pc,a);
          return *this;         };
*/

   MyString operator+(const char* a) const
        { return *new(MyStringF(Frt().pc,a)); };
/*      { const MyStringF& O=Frt();
          MyStringF&       N=*new(MyStringF(strlen(O.pc)+strlen(a)+1) );
          strcpy(N.pc,O.pc); strcat(N.pc,a);
          return N;                          };
*/
   operator const char*() const { return Frt().pc;              };
   char* NewCharPtr() const // NO: operator char*() const !!
        { char* c=new(char[strlen(Frt().pc)+1]); strcpy(c,Frt().pc); return c; };

 friend MyString operator+(const char * a,const MyString& S);
};
