// PROJECT : ALIB
// FILE    : ALSTRING.CPP - implementation of some PORTABle stuff
// AUTHOR  : Michael Vorburger, alpha ware
// DATE oC : August 1994
// DATE oLM: August 1994
// LEVEL   : GLE

#include <alstring.h>
#if !defined(UseStringLib)   // Verwende Str++ 3.0 (download von Fido) ?

istream& operator>> (istream& i, String& s)
  { char buf[81];
    i.get(buf,80,'\n'); // war: cin.get(...)
    s.EqualFruitPtr(new StringFruit(buf));
    return i;
  };

String operator+ (const char* a, const String& b)
  { return String(a) + b; };

#else

/* Das definiert diese String-Klasse selbst in STR.CPP
istream& operator>> (istream& i, String& s)
  { char buf[81];
    i.get(buf,80,'\n'); // war: cin.get(...)
    s=buf;
    return i;
  };
*/
#endif

ostream& operator << ( ostream& s, const isASCIIable& o)
  { s << o.AsASCII(); return s; };
