/* PROBLEM: Darf eine pvf durch eine andere mit gendertem Funktionstyp
            berladen werden?
   ANTWORT: Ja, wenn die erste Deklaration wiederholt wird, siehe unten.
*/

#include <portab.h>
#pragma warn -inl
typedef char O;

class Iter
{ public:
    virtual O& Get() = 0;
};

class AnIter : public Iter
{ public:
    AnIter(const UWORD i) {};
    O& Get() {};
};

class Container
{ public:
   virtual O& Get(Iter& i) { return i.Get(); }; // a) { ... }  b) = 0;
};
// Wenn Get pure-virtual ist (b), "darf" der Typ des Arguments unten gendert
// werden, dh. es gibt eine andere Funktion (berladen wie gewhnlich). Wenn
// Get() aber einen Funktionsrumpf hat, hat der blde Compi(ler) pltztlich
// das Gefhl Get(const UWORD) (su.) verdecke die obere Funktion...

class OrdContainer : public Container
{ public:
   O& Get(Iter& i) { return i.Get(); };

// DIESE ZEILE MUSS HIER STEHEN! ALTE DEKLARATION VON Get() WIEDERHOLEN!
//  virtual O& Get(const UWORD) = 0;
};

class ArrayIntf : public OrdContainer
{ public:
   virtual O& Get(Iter& i)     {}; // C (su.)
   virtual O& Get(const UWORD j) { AnIter I(j);
                                   /*OrdContainer:: */Get((Iter&)I); }; // D)
};
// Anderes Problem: Wenn C) oben auskommentiert wird, funktioniert der
// Funktionsaufruf von Get() in Get() bei D) nur noch mit "vollstndigem
// Namen" oder wie das mit dem :: immer heisst.

void main()
{
  OrdContainer& C=*new ArrayIntf;
  AnIter        I(0);

  C.Get(I);
  C.Get(2);
};


