/*
class Quotient : public Operator
{
  private:
	Term& z;	// Zhler
	Term& n;	// Nenner
  // MUST be a TERM!!!

  public:
	Quotient(TermFruit& zaehler, TermFruit& nenner )
	 : z(zaehler),
	   n(nenner)
	 { ; };

//	TermFruit& operator/= (const SWORD v);
//	TermFruit& operator/= (const TermFruit& t);
//	virtual TermFruit& operator/ (Quotient& t)
	virtual TermFruit& DivideByInteger(Integer& t)
	  { Error(ErrUnknownClass); };

	virtual String AsASCII() const
	  {
		String& t=*new String;   // was heisst denn t=String(); ??

		t << z.AsASCII() << '/' << n.AsASCII();
        return t;

//		return( z.AsASCII() + '/' + n.AsASCII() );
// 				gibt ambiguity-Probleme!
	  };

	virtual BOOL IsA(UWORD id) const
		{ return( id==IdQuotient || TermFruit::IsA(id) ); };
	virtual UWORD TypeOf() const
		{ return IdQuotient; };
};
*/

    virtual TermFruit& Plus(const TermFruit& t) const;
    virtual TermFruit& Multiply(const TermFruit& t) const;
	virtual TermFruit& Power(const TermFruit& t) const;

TermFruit& operator* (const Term& t)
{  switch ( t().TypeOf() ) {
          case IdInteger  : return r->MultiplyInteger( TC(t(), Integer&) );
          case IdVariable : return r->MultiplyVariable( TC(t(), Variable&) );
          case IdMultiply : return r->MultiplyMultiply( TC(t(), Multiply&) );
          case IdPlus     : return r->MultiplyPlus( TC(t(), Plus&) );
          case IdPower    : return r->MultiplyPower( TC(t(), Power&) );
          default		  : Error(ErrUnknownClass);
                            return INVTerm;
}; };

TermFruit& operator^ (const Term& t)
{		switch ( t().TypeOf() ) {
          case IdInteger  : return r->PowerInteger( TC(t(), Integer&) );
          case IdVariable : return r->PowerVariable( TC(t(), Variable&) );
          case IdMultiply : return r->PowerMultiply( TC(t(), Multiply&) );
          case IdPlus     : return r->PowerPlus( TC(t(), Plus&) );
          case IdPower    : return r->PowerPower( TC(t(), Power&) );
          default		  : Error(ErrUnknownClass);
                            return INVTerm;
		};
};


from class Integer && Variable && Plus && Multiply && Power
{
    virtual TermFruit& PlusInteger(const Integer& t) const;
    virtual TermFruit& PlusVariable(const Variable& t) const;
	virtual TermFruit& PlusMultiply(const Multiply& t) const;
	virtual TermFruit& PlusPlus(const Plus& t) const;
	virtual TermFruit& PlusPower(const Power& t) const;

	virtual TermFruit& MultiplyInteger(const Integer& t) const;
	virtual TermFruit& MultiplyVariable(const Variable& t) const;
	virtual TermFruit& MultiplyMultiply(const Multiply& t) const;
	virtual TermFruit& MultiplyPlus(const Plus& t) const;
	virtual TermFruit& MultiplyPower(const Power& t) const;

	virtual TermFruit& PowerAll(const TermFruit& t) const;

    virtual TermFruit& Negative() const;
}

from TermFruit& Term::operator+ (const Term& t) const
{
		switch ( t().TypeOf() ) {
          case IdInteger  : return r->PlusInteger( TC(t(), Integer&) );
          case IdVariable : return r->PlusVariable( TC(t(), Variable&) );
          case IdMultiply : return r->PlusMultiply( TC(t(), Multiply&) );
          case IdPlus     : return r->PlusPlus( TC(t(), Plus&) );
          case IdPower    : return r->PlusPower( TC(t(), Power&) );
          default		  : Error(ErrUnknownClass);
                            return INVTerm;
		};
};

/*
inline TermFruit& T_INVTerm::PlusInteger(const Integer& t) const      { return INVTerm; };
inline TermFruit& T_INVTerm::PlusVariable(const Variable& t) const    { return INVTerm; };
inline TermFruit& T_INVTerm::PlusMultiply(const Multiply& t) const    { return INVTerm; };
inline TermFruit& T_INVTerm::PlusPlus(const Plus& t) const            { return INVTerm; };
inline TermFruit& T_INVTerm::PlusPower(const Power& t) const          { return INVTerm; };
inline TermFruit& T_INVTerm::MultiplyInteger(const Integer& t) const  { return INVTerm; };
inline TermFruit& T_INVTerm::MultiplyVariable(const Variable& t) const{ return INVTerm; };
inline TermFruit& T_INVTerm::MultiplyMultiply(const Multiply& t) const{ return INVTerm; };
inline TermFruit& T_INVTerm::MultiplyPlus(const Plus& t) const        { return INVTerm; };
inline TermFruit& T_INVTerm::MultiplyPower(const Power& t) const      { return INVTerm; };
*/

/*
inline TermFruit& T_INVERR_TermFruit::Plus(TermFruit& t,CalcType ct)      { return *this; };
inline TermFruit& T_INVERR_TermFruit::Multiply(TermFruit& t,CalcType ct)  { return *this; };
inline TermFruit& T_INVERR_TermFruit::Power(TermFruit& t,CalcType ct)     { return *this; };
//inline Numerical& T_INVERR_TermFruit::NPow(Numerical& e)                  { return *this; };
inline bool T_INVERR_TermFruit::IsZero() const                            { return false; };
inline bool T_INVERR_TermFruit::IsPositive() const                        { return true;  };
inline bool T_INVERR_TermFruit::IsOne() const                             { return false; };
*/
/*
inline TermFruit::operator bool()
//  { return bool(this != &INVTerm); };
  { bool temp;
    T_INVERR_TermFruit* t=this;
    temp=bool(this != &INVTerm);// bool(TypeOf()!=IdINVTerm);
    cout << "TermFruit an " << this << "gltig? : " << temp << endl;
    return temp;
  };
*/

/* -------------------------------------------------------------------*/
/*
TermFruit& Numerical::NPow_(Numerical& e)
{ // Diese Methode prft zuerst allg, ob nicht unerlaubterweise Null mit einer
  // negativen Zahl potenziert wird und ruft dann die spezifische Methode (von
  // Integer, Real usw) auf. Falls das nicht geklappt hat, wird eine symbo-
  // lische Potenz zurckgeliefert.

  if(IsZero() )
    if(e.IsPositive() )
      { Numerical& t=NPow(e);
        if (t) return t;
        else return *new PowerClass(*this, e);    }
    else
      { Error(ErrDivByZero); return INVTerm; }
  else
    { Numerical& t=NPow(e);
      if (t) return t;
      else return *new PowerClass(*this, e);    };
        // ev. auf grsseren Bereich umschalten; dh. zB. Integer in Real wandeln.
};

Numerical& Integer::NPow(Numerical& e)
{
  if(e.IsA(IdInteger) )
    { //SWORD a=TC(e,Integer&).i;
      //SWORD b=SWORD(log10(MAXINT) / log10(abs(i)));
      if( TC(e,Integer&).i <= SWORD(log10(MAXINT) / log10(abs(i))) )
        { i=pow(i,TC(e,Integer&).i); return *this; }
      else
        return INVTerm;
    }
  else
    { Error(ErrOperUnknownType); return INVTerm; };
    // Wenn ALIB mal voll dyn.Typumwandlung untersttzt, knnte *this
    // in ein Objekt von Typ von e umgewandelt und das pow() darauf an-
    // gewendet werden. Ungefhr so:
/*
    Numerical& temp = CreateObject( TypeOf(e) );
    temp(*this); // init new object of type of e with "myself"
    temp.NPow(e);
    return temp;
*/
*/
/*
};
TermFruit& Integer::Power(TermFruit& e, CalcType how)
{ if (e.IsA(IdNumerical))
    return NPow_(TC(e, Numerical&));  // ACHTUNG: berlauf wird noch nicht abgefangen!
  else
    return *new PowerClass(*this, e);  };
*/
/* -------------------------------------------------------------------*/

