// REF_UMBG: Referenzen in Funktionen umbiegen.

// PROJECT: alpha lib (term)
// AUTHOR : Mike Vorburger, alpha ware
// DATE   : 2/23/94


class C
{
  public:
	  int i;
//	  operator C**()		// geht eben leider nd!
//	  { return &this; };
};

class R	// root
{
  private:
//  C& root;
	C* root;
  public:
//	R() : root(*new C) { };
	R() { root=new C; };
	R& operator/= (int d);
	R& operator= (int d)
	{ (*root).i=d; return *this; };
};

// Fehler: ... must be a member function or have a parameter of class type
// C& operator/= (C* &c, int d)	// C& *c : Cannot define a pointer to a ref
void divide(C* *c, int d)
{ int t=(**c).i;

  *c=new C;
  (**c).i=int(t/d);
//  return c;
};

R& R::operator/= (int d)
{
  divide(&root,d);
  return *this;
};

int& Force(int& i)	// i ist Referenz auf Zeiger vom Typ int
{
  &i = new int( i * 2 );
  return i;
};


void main()
{
   R& o=*new R;
   o=8;
   o/=2;   // yop! o.root zeigt wirklich auf ein anderes Objekt.

   C& s=*new C;
   s.i =9;
   // Idee: statt & &s knnte man versuchen, einen cast-Op einzubauen (s.o.)
   divide(& &s,3);	// ja nicht &&s
   // s zeigt jetzt auf ein anderes Objekt!

   int& g = 3;
   Force(g);  	// g wird whrend Force 6 und nachher wieder 3
   g=Force(g);  // g wird & bleibt 6
};