#include <alobject.h>
//#include <portab.h>
//#include <new.h>
//#include <alloc.h>
//#include <error.h>

#include "samples\handle\hnd_tpl.h"

/* -------------------------------------------------------------------------*/

/*
class Char : public Hnd<char>
{public:
  Char()                  : Hnd<char>('0')      { };
  Char(char pC)           : Hnd<char>(pC)       { };
  Char(Hnd<char>& cpy)    : Hnd<char>(cpy)      { };
  operator       char()   { return operator() (); };
};

class Virt : public Hnd<long>
{public:
          Virt()    : Hnd<long>(0) {  };
  virtual ~Virt()   {                 };
  virtual int foo() { return 7;       };
};

class Memb : public Hnd<char>
{  char c;
 public:
   Memb() : Hnd<char>(c) { };
};


template<class T> class ListTpl
{public:
   void Add(T a) { item=a;      };
      T Get()    { return item; };

 private:
   T item;
};

void Test1()
{
   ListTpl<Char> L;

   L.Add('M');
   char Q=L.Get();
   cout << Q;
};

template<class T> class ListHnd : private ListTpl< Hnd<char> >
{ typedef ListTpl< Hnd<char> > Eng;
 public:
   void Add(Hnd<char> a) { Eng::Add(a); };
   T    Get()         { return Eng::Get(); };
};
void Test2()
{
   ListHnd<Char> L;

   L.Add('K');
   char Q=L.Get();
   cout << Q;
};
*/
#if (sizeof(MyChar)!=sizeof(Hnd<CharF>))
          #error Uops! Your handle has additional data members or virtual members
#endif

class Base { };
class Child : public Base { };

template<class T> class ListTpl
{  T item;
 public:
   void  Add(const T& a) { item=a;      };
      T& Get()           { return item; };
};
typedef ListTpl<ShellEngine> List_Hnd;
typedef ListTpl<Base>        List_Base;

template<class T> class ListBase : private List_Base
{ typedef List_Base Eng;
 public:
   void Add(const T& a) { Eng::Add(a);   };
   T&   Get()           { return (T&)Eng::Get(); };
};

template<class T, class F> class ListHnd : private List_Hnd
{  typedef List_Hnd Eng;
 public:
   void Add(const T& a) { //const Fruit&      cF=a;
                               //const Hnd<Fruit>& H=(const Hnd<Fruit>)a;
                               Eng::Add(a);       };

        T Get()         { return (Hnd<F>)Eng::Get(); };
};

/*
template<class T, class F> class ListHnd : private ListTpl<Hnd<F> >
{  typedef ListTpl<Hnd<F> > Eng;
 public:
   void Add(const T& a) { Eng::Add(a);       };
        T Get()         { return Eng::Get(); };
};
*/
void main()
{
   ListTpl<MyChar> L0;
   L0.Add('M'); MyChar R0=L0.Get(); R0.Print();

   ListBase<Child> L2;
   Child c1; L2.Add(c1); Child c2=L2.Get();

   ListHnd<MyChar,CharF> L1;
   L1.Add('N');  /* ??? */
   MyChar R1=L1.Get();
   R1.Print();

/* ListTpl<WArr> L2;
   L2.Add(2);
   WArr R2=L2.Get();
   R2.Show();
   R2.NonConstG().Show();
   R2.Show();

   L2.Add(7);
   R2=L2.Get();
   R2.Show();
*/
};
