 // How many bytes??

#include <portab.h>

template<class T> class SPtr {
 public:

   T* operator->() { return r;  };
   T& operator*()  { return *r; };

   const T* operator->() const { return r;  };
   const T& operator*()  const { return *r; };

   SPtr(T& o)       : r(&o)   { r->refs++;        };
   SPtr(T* p)       : r(p)    { if (r) r->refs++; };
   SPtr(SPtr<T>& s) : r(s.r)  { if (r) r->refs++; };
   SPtr()           : r(NULL) {                   };

   ~SPtr()
     { if (r) r->refs--;
       if (!(r->refs)) delete r;  };

   SPtr& operator=(T& o)
     { o.refs++;
       if (r) r->refs--;
       if (!(r->refs)) delete r;
       r=&o;
       return *this;            };

   SPtr& operator=(T* p)
     { if (p) p->refs++;
       if (r) r->refs--;
       if (!(r->refs)) delete r;
       r=p;
       return *this;            };

   SPtr& operator=(SPtr<T>& s)
     { s.r->refs++;
       if (r) r->refs--;
       if (!(r->refs)) delete r;
       r=s.r;
       return *this;            };

          bool operator==(const T* p)       const { return   p==r; };
          bool operator==(const SPtr<T>& s) const { return s.r==r; };
   friend bool operator==(const T* p, const SPtr<T> SP);
          bool operator!=(const T* p)       const { return   p!=r; };
          bool operator!=(const SPtr<T>& s) const { return s.r!=r; };
   friend bool operator!=(const T* p, const SPtr<T> SP);
   // No comp with Typ T& because that could be confusing.

 public: // private: (PROBLEM)
   T* r;
};

struct C { char* pc; int refs; };

int main()
{
  SPtr<C> p;

  p=new C;  // How many bytes??

  p=new C;
};