// STR_TST -- bungs- und Testprogramm fr <ALSTRING>

// PROJECT : alpha lib
// AUTHOR  : Michael Vorburger, alpha ware, CH-SG
// DATE oC : March 1994
// DATE oLM: August 1994

#include <alphalib.h>
//#include <alobject.h>
//#include <error.h>

//#include <alstring.h>
// #include <str.h>

/*
class StringFruitII : public StringFruit
{ public:
   SWORD j;

   StringFruitII(StringFruitII& i) : StringFruit(i)
     { j=i.j; };
   StringFruitII(int i) : StringFruit("child")
     { j=i; };
};
StringFruit& f(int i)
  { return *new StringFruitII(i); };
*/

String Add(const String& t)
  { return " Hi, "+t+"!"; };
// Also Junge, Regel 23 von Meyers: Ein neu erzeugtes Objekt MUSS als
// Wert zurckgegeben werden! Also kein String& und nix mit *new, klaro?

class F : public Fruit
{ public:
   FRUITMACRO(F)
};

#include <conio.h>
#define DOC(stat,X) cout << "$$ "; cout.width(24); cout.setf(ios::left); cout.fill(' '); cout << #stat << ">"; stat gotoxy(50,wherey()); cout << "< "; cout.width(4); cout.fill(' '); cout << #X << "= "; cout << X << endl;
#define INFO(txt) cout << ":" << txt << endl << endl;

void main()
{
  DOC(String s1="Mike";,s1)
  DOC(String s2="Vorburger";,s2)
  DOC(String s3;,'-')

  DOC(Shell<F> sh;,'-')
  INFO("sizeof(Shell<F>) = " << sizeof(sh) << ", sizeof(String) = " << sizeof(String) << ", sizeof(s1) = " << sizeof(s1))

  DOC(s3=278;,s3)
  DOC(s3=s1;,s3)
  DOC(,(s3==s1))
  //cout << "s3==s1 : " << (s3==s1) << endl;

  DOC(s3[0]='D';,s3)
  DOC( ,s1)
  //cout << s3 << " " << s1 << endl;
  DOC(,(s3==s1))
  // s3.Reset();   // NICHT NTIG - geht automatisch!
  INFO("s2==\"Vorburger\" : " << (s2=="Vorburger"))

  DOC(s3=s1+" 3";,s3)
  DOC(s1=s1+" 1";,s1)
  DOC(s1="Mike";,s1)

  DOC(s3=Add(s1);,s3)

  String s6;
  s6=s1 + " " + s2;
  cout << s6 << endl;

  s6=s1 + s2 + "?";
  cout << s6 << endl;

  String s9, s10;
  s9=s1;
  s9+="@"+s2;
  cout << s9 << endl;

  const char* c1;
//  char*       c2;

  s3=s1; // flat copy; "Mike" is NOT duplicated
  c1=s3; // flat copy too

/*  c2=s3; // deep copy of "Mike"
    c2=s3.NewCharP();

  c2[0]='X';
  cout << s3 << endl;

  String s4(c1);  // c1 is const -> anyway deep copy!
  String s5(c2);  // c2 isnt cst -> deep copy!

  delete c2;      // c2 selber freigeben!!!
*/

  s1="abc";
  s2="abd";
  cout << "s1 > s2 : " << (s1>s2) << endl;
  cout << "s1 < s2 : " << (s1<s2) << endl;
  cout << "s1 > \"aba\" : " << (s1>"aba") << endl;

  cout << "Eingabe: ";
  cin >> s3;
  cout << s3 << endl;

};
