// PROJECT : ALIB
// FILE    : MSITEXT.C - machine specific implementation, text interface
// AUTHOR  : Michael Vorburger, alpha ware
// DATE oC : October 1994
// DATE oLM: October 1994
// LEVEL   : MSI

#include <msitext.h>

// NativePrint() is a low level textscreen-output function. Don't use printf()
// or even cout here! Reentrance problems are one thing...

// TxtCursX() return X-Position of text cursor from 1..80 (maybe more than 80,
// or always 1)

const char* CR="\r\n";

#ifdef env_DOS
#  include <conio.h>
void NativePrint(const char* cp)  { cputs(cp); 		  };
int TxtCursX() 						 { return wherex(); };
#else
#  include <stdio.h>
void NativePrint(const char* cp)  { puts(cp); 		  };
int TxtCursX() 						 { return 1;		  };
#endif


