// PROGRAM AND DESCRIPTION
// Dies ist ein Testprogramm zum ben von Termauswertungen. Es wertet
// Ausdrcke wie '(6+12)/3/(3-1*1)' (gibt 3) aus. Arbeitet mit Rekursion.

// AUTHOR AND DATE
// Michael Vorburger, september 1993


#include <stdio.h>
#include <stdlib.h>

#define BOOL  int
#define FALSE 0
#define TRUE  !FALSE

#define BASETYPE  int   // Type der "Basis", hier der Zahlen
#define MaxLenBez 20 	// Maximale Lnge von Bezeichern (hier: Zahlen)

char 	term[80];
typedef enum { PLUSMINUS, MULTIDIVIDE } LEVEL;
typedef enum { SEARCH_NUMBER, SEARCH_OP } MODE;

BASETYPE evaluate(LEVEL level)
{
	static int nPosTerm = 0;

	char szNumber[MaxLenBez];	// Hilfsspeicher zur Umwandlung String -> Zahl
	int	 nPosNumber = 0;		// Position im Hilfsspeicher
//	int  nNumber;				// in Integer imgewandelte Zahl (aus String)
	BOOL fCont = TRUE;			//
	BASETYPE r = 0;				// Zwischenresultat
	MODE mode  = SEARCH_NUMBER;

	while ( fCont )
	{
		switch ( term[nPosTerm] ) {
			case '0' :
			case '1' :
			case '2' :
			case '3' :
			case '4' :
			case '5' :
			case '6' :
			case '7' :
			case '8' :
			case '9' :
					   szNumber[nPosNumber++] = term[nPosTerm++]; break;
			case '-' :
			case '+' :
					   if ( mode == SEARCH_NUMBER /* nPosNumber == 0 */ )
						   { szNumber[nPosNumber++] = term[nPosTerm++];	break; };
						 // +/- als Prfixe
			case '*' :
			case '/' :   // +/-/*/ als Operatoren
					   szNumber[nPosNumber] = 0;
					   r = ( mode == SEARCH_NUMBER ? atoi( szNumber ) : r );
					   nPosNumber = 0;
					   if ( level == SEARCH_OP ) {
						   switch ( term[nPosTerm++] ) {
							   case '+' : r += evaluate( PLUSMINUS ); break;
							   case '-' : r -= evaluate( PLUSMINUS ); break;
							   case '*' : r *= evaluate( MULTIDIVIDE ); break;
							   case '/' : r /= evaluate( MULTIDIVIDE ); break;
							   case  0  : fCont = FALSE;
						   }
					   }
					   else fCont = FALSE;
					   break;
			case ' ' : nPosNumber++; break;
			case  0  : if ( nPosNumber ) { szNumber[nPosNumber] = 0; r = atoi( szNumber ); }
					   fCont = FALSE; break;
			default  : puts("ERROR ab "); puts( &term[nPosTerm++] );

		};  // select case
	};		// while

	return( r );
};


void main()
{
	char 		szResultString[20];
	BASETYPE    Result;

	puts("Geben Sie einen Term ein: ");
	gets( term );

	puts("Ergebnis: ");
	Result = evaluate( PLUSMINUS );
	itoa(Result, szResultString, 10);
	puts( szResultString );
};